const APP_DISPLAY_NAME = "ChromEdit";
const APP_NAME = "chromedit";
const LIB_NAME = "jslib";
const APP_PACKAGE = "/cdn.mozdev.org/chromEdit";
const APP_VERSION = "0.0.5.1";
const LIB_VERSION = "20030523";

const APP_JAR_FILE = "chromedit.jar";
const LIB_JAR_FILE = "jslib.jar";
const APP_CONTENT_FOLDER = "content/";
const APP_SKIN_FOLDER  = "skin/classic/";
const LIB_CONTENT_FOLDER  = "/";

const APP_SUCCESS_MESSAGE = "You may need to restart your Mozilla application before this works.";

const INST_TO_PROFILE = "Do you wish to install "+APP_DISPLAY_NAME+" to your profile?\nThis will mean it does not need reinstalling when you update your application.\n(Click Cancel if you want "+APP_DISPLAY_NAME+" installing to the application directory.)";

initInstall(APP_NAME, APP_PACKAGE, APP_VERSION);

// profile installs only work since 2003-03-06
var instToProfile = ((buildID>2003030600 || buildID==0000000000) && confirm(INST_TO_PROFILE));

var chromef = instToProfile ? getFolder("Profile", "chrome") : getFolder("chrome");
var err = addFile(APP_PACKAGE, APP_VERSION, 'chrome/' + APP_JAR_FILE, chromef, null);
//var err2 = addFile(LIB_PACKAGE, LIB_VERSION, LIB_JAR_FILE, chromef, null);
if (err == SUCCESS) {
  var iconfolder = getFolder(getFolder("chrome", "icons"), "default");
  addFile(APP_NAME, "defaults/ce-main.xpm", iconfolder, "");
  addFile(APP_NAME, "defaults/ce-main.ico", iconfolder, "");
}
if(err == SUCCESS) {
	var jar = getFolder(chromef, APP_JAR_FILE);
	if(instToProfile) {
  	registerChrome(CONTENT | PROFILE_CHROME, jar, APP_CONTENT_FOLDER);
  	registerChrome(SKIN    | PROFILE_CHROME, jar, APP_SKIN_FOLDER);
  } else {
  	registerChrome(CONTENT | DELAYED_CHROME, jar, APP_CONTENT_FOLDER);
  	registerChrome(SKIN    | DELAYED_CHROME, jar, APP_SKIN_FOLDER);
  }
	err = performInstall();
	if(err == SUCCESS || err == 999) {
		alert(APP_DISPLAY_NAME+" "+APP_VERSION+" has been succesfully installed.\n"+APP_SUCCESS_MESSAGE);
	} else {
		alert("Install failed. Error code:" + err);
		cancelInstall(err);
	}
} else {
	alert("Failed to create " +APP_JAR_FILE +"\n"
		+"You probably don't have appropriate permissions \n"
		+"(write access to your profile or chrome directory). \n"
		+"_____________________________\nError code:" + err);
	cancelInstall(err);
}
